#include <amxmodx>
#include <amxmisc>
#include <ns2amx>

/* COMMBAN.SMA - 0.14.2
 * -
 * Bans players from becoming commanders.
 * -
 * No warrenties of any kind.
 */


#define COMMBAN_MAXBANS		64		// Maximum number of commbans.
#define COMMBAN_ACCESS		ADMIN_KICK	// Access level to use all of the commands.
#define COMMBAN_ECHOBANS	0		// Whether to echo the bans as the server loads them (debugging).

// Don't edit below here...


#define COMMBAN_CLIENTPRINT	print_console

new currentban
new szBanned[COMMBAN_MAXBANS][33]
new BanTime[COMMBAN_MAXBANS] // To save for re-dumping of the ban file.
new gmsgHudText2
new SIClass[33] // Quick hack so I don't need nshelpers.inc for get_class()
new g_filename[256]


enum {
   PLAYERCLASS_NONE = 0,
   PLAYERCLASS_ALIVE_MARINE,
   PLAYERCLASS_ALIVE_ALIEN,
   PLAYERCLASS_ALIVE_JETPACK,
   PLAYERCLASS_ALIVE_HEAVY_MARINE,
   PLAYERCLASS_ALIVE_LEVEL1,
   PLAYERCLASS_ALIVE_LEVEL2,
   PLAYERCLASS_ALIVE_LEVEL3,
   PLAYERCLASS_ALIVE_LEVEL4,
   PLAYERCLASS_ALIVE_LEVEL5,
   PLAYERCLASS_ALIVE_DIGESTING,
   PLAYERCLASS_ALIVE_GESTATING,
   PLAYERCLASS_DEAD_MARINE,
   PLAYERCLASS_DEAD_ALIEN,
   PLAYERCLASS_COMMANDER,
   PLAYERCLASS_REINFORCING,
   PLAYERCLASS_SPECTATOR
};

public plugin_init()
{
	get_configsdir(g_filename,255)
	format(g_filename,255,"%s/commban.ini",g_filename) 
	register_plugin("commban","0.9","mahnsawce/AssKicR")
	register_clcmd("dumpbans","dump_bans")
	register_clcmd("amx_commban","commban",COMMBAN_ACCESS,"<name or authid> <minutes or -1 for infinite>")
	register_clcmd("amx_uncommban","uncommban",COMMBAN_ACCESS,"<authid>")
	register_clcmd("amx_commbanlist","listcommban",COMMBAN_ACCESS,"- Lists all commander bans.")

	gmsgHudText2=get_user_msgid("HudText2")
	if (!file_exists(g_filename))
	{
		// Commban file does not exist, so create it.
		write_file(g_filename,"")
	}
	for (new i=0;i<=32;i++)
		SIClass[i]=0;
	clear_bans()
	precache_bans(COMMBAN_ECHOBANS)

	register_event("ScoreInfo","scoreinfo","ab")
}
public clear_bans()
{
	currentban=0
	for (new i=0;i<=(COMMBAN_MAXBANS - 1);i++)
	{
		copy(szBanned[i],32,"")
	}
}
public precache_bans(iDisp)
{
	// Format in commban.ini:
	// authid time()

	new AuthID[32]
	new Time[32]
	new iTime
	new iNextLine=1
	new szRead[256]
	new ReadSize
	new nextline=0
	new curline=0
	while (iNextLine > 0)
	{
		curline=nextline
		if (iNextLine == 1)
		{
			nextline = read_file(g_filename,curline,szRead,255,ReadSize)
			if (nextline == 0)
			{
				iNextLine = 0
			}
			parse(szRead,AuthID,32,Time,32)
			iTime=str_to_num(Time)
			if (time() > iTime && iTime > 0) // we've got an expired ban here...
			{
				// Just right over it for now, we'll redump the ban list sooner or later.
				write_file(g_filename,"",curline)
			}
			else if (!(AuthID[0]=='S' && AuthID[1]=='T' && AuthID[2]=='E' && AuthID[3]=='A' && AuthID[4]=='M' && AuthID[5]=='_'))
			{
				// Invalid AuthID
				write_file(g_filename,"",curline)
			}
			else
			{
				if (isbannedid(AuthID) == 0)
				{
					BanTime[currentban]=iTime
					copy(szBanned[currentban],32,AuthID)
					if (iDisp)
					{
						if (iTime == -1)
							server_print("[COMMBAN] Added ban for %s which never expires.",szBanned[currentban])
						else
							server_print("[COMMBAN] Added ban for %s which expires in %d minutes",szBanned[currentban],(iTime - time()) / 60)
					}
					currentban++
				}
			}
		}
		
	}	
}
public dump_bans()
{
	new i
	new szString[256]
	if (file_exists(g_filename))
	{
		delete_file(g_filename)
	}
	if (currentban == 0)
	{
		// If there are no bans, just make an empty file (I'm an idiot)
		write_file(g_filename,"")
	}
	for (i=0;i<=currentban - 1;i++)
	{
		format(szString,255,"%s %i",szBanned[i],BanTime[i])
		write_file(g_filename,szString)
	}
}
public isbannedid(szAuthId[])
{
	for (new i=0;i<=(COMMBAN_MAXBANS - 1);i++)
	{
		if (equal(szAuthId,szBanned[i]))
		{
			return 1
		}
	}
	return 0
}
public uncommban(id,level,cid)
{
	if (!cmd_access(id,level,cid,2))
		return PLUGIN_HANDLED
	new AuthID[32]
	read_argv(1,AuthID,32)
	if (delban(AuthID))
	{
		client_print(id,COMMBAN_CLIENTPRINT,"[AMX] Commaner ban successfully removed.")
		return PLUGIN_HANDLED
	}
	client_print(id,COMMBAN_CLIENTPRINT,"[AMX] Commander ban does not exist.")
	return PLUGIN_HANDLED
	
}
public listcommban(id,level,cid)
{
	if (!cmd_access(id,level,cid,1))
		return PLUGIN_HANDLED
	new i
	for (i=0;i<=currentban - 1;i++)
	{
		if (BanTime[i] != -1)
			client_print(id,print_console,"%i %s - Time left: %i min",i + 1,szBanned[i],(BanTime[i] - time()) / 60)
		else
			client_print(id,print_console,"%i %s - Time left: Infinite",i + 1,szBanned[i])
	}
	return PLUGIN_HANDLED
}

public commban(id,level,cid)
{
	if (!cmd_access(id,level,cid,1))
		return PLUGIN_HANDLED
	if (read_argc() == 1)
	{
		new foundcomm=0
		new name[33]
		// We are banning the active commander for 1 week...
		for (new i=1;i<=get_maxplayers();i++)
		{
			if (is_user_connected(i))
			{
				// HACK: Created SIClass array so I don't need ns2amx for get_class
				if (SIClass[i] == CLASS_COMMANDER)
				{
					// Player is commander...
					foundcomm=1
					engclient_cmd(i,"stopcommandermode")
					set_task(0.1,"notifyban",i)
					new AuthID[32]
					get_user_authid(i,AuthID,32)
					get_user_name(i,name,32)
					if (!isbannedid(AuthID))
					{
						ban_id(id,AuthID,40320)
					}
				}
			}
		}
		if (foundcomm == 1)
		{
			new msgstring[189]
			format(msgstring,189,"[AMX]  %s has been banned from commanding for 1 week.",name)
			client_print(id,COMMBAN_CLIENTPRINT,msgstring)
		}
		else
		{
			client_print(id,COMMBAN_CLIENTPRINT,"[AMX] There is no active commander.")
		}
		return PLUGIN_HANDLED
	}
	if (read_argc() == 2)
	{
		// Just user... ban for 1 hour
		new arg1[32]
		new target
		read_argv(1,arg1,32)
		target = cmd_target2(id,arg1,8)
		if (target > 0 && target < 33)
		{
			// We found a valid player as a target, so we commban him.
			new AuthID[32]
			new name[32]
			get_user_authid(target,AuthID,32)
			get_user_name(target,name,32)
			if (!isbannedid(AuthID))
			{
				ban_id(id,AuthID,60)
			}
			else
			{
				client_print(id,COMMBAN_CLIENTPRINT,"[AMX] Comm ban for %s already exists.",AuthID)
			}
			// Check if he's currently the commander...
			if (SIClass[target] == CLASS_COMMANDER)
			{
				engclient_cmd(target,"stopcommandermode")
				set_task(0.1,"notifyban",target)
			}
			return PLUGIN_HANDLED
		}
		else
		{
			// The given player isn't an auth id, verify it's a steam id...
			if (arg1[0]=='S' && arg1[1]=='T' && arg1[2]=='E' && arg1[3]=='A' && arg1[4]=='M' && arg1[5]=='_')
			{
				new AuthID[32]
				copy(AuthID,32,arg1)
				if (!isbannedid(AuthID))
				{
					ban_id(id,AuthID,60)
				}
				else
				{
					client_print(id,COMMBAN_CLIENTPRINT,"[AMX] Comm ban for %s already exists.",AuthID)
				}

				target = find_player("cj",AuthID)
				if (target > 0 && target < 33)
				{
					if (SIClass[target] == CLASS_COMMANDER)
					{
						engclient_cmd(target,"stopcommandermode")
						set_task(0.1,"notifyban",target)
					}
				}
			}
			else
			{
				client_print(id,COMMBAN_CLIENTPRINT,"[AMX] Comm bans can only ban nicknames or Steam IDs. (Must start with ^"STEAM_^")")
			}
			return PLUGIN_HANDLED

		}
		
	}
	else
	{
		// Just user... ban for 1 hour
		new arg1[32]
		new arg2[32]
		new target
		read_argv(1,arg1,32)
		read_argv(2,arg2,32)
		new btime = str_to_num(arg2)
		target = cmd_target2(id,arg1,8)
		if (target > 0 && target < 33)
		{
			// We found a valid player as a target, so we commban him.
			new AuthID[32]
			new name[32]
			get_user_authid(target,AuthID,32)
			get_user_name(target,name,32)
			if (!isbannedid(AuthID))
			{
				ban_id(id,AuthID,btime)
			}
			else
			{
				client_print(id,COMMBAN_CLIENTPRINT,"[AMX] Comm ban for %s already exists.",AuthID)
			}
			// Check if he's currently the commander...
			if (SIClass[target] == CLASS_COMMANDER)
			{
				engclient_cmd(target,"stopcommandermode")
				set_task(0.1,"notifyban",target)
			}
			return PLUGIN_HANDLED
		}
		else
		{
			// The given player isn't an auth id, verify it's a steam id...
			if (arg1[0]=='S' && arg1[1]=='T' && arg1[2]=='E' && arg1[3]=='A' && arg1[4]=='M' && arg1[5]=='_')
			{
				new AuthID[32]
				copy(AuthID,32,arg1)
				if (!isbannedid(AuthID))
				{
					ban_id(id,AuthID,btime)
				}
				else
				{
					client_print(id,COMMBAN_CLIENTPRINT,"[AMX] Comm ban for %s already exists.",AuthID)
				}

				target = find_player("cj",AuthID)
				if (target > 0 && target < 33)
				{
					if (SIClass[target] == CLASS_COMMANDER)
					{
						engclient_cmd(target,"stopcommandermode")
						set_task(0.1,"notifyban",target)
					}
				}
			}
			else
			{
				client_print(id,COMMBAN_CLIENTPRINT,"[AMX] Comm bans can only ban nicknames or Steam IDs. (Must start with ^"STEAM_^")")
			}
			return PLUGIN_HANDLED

		}
		
	}
	return PLUGIN_HANDLED
}
// delban routine - delete from active cache of bans then dump to the ini file
public delban(AuthID[])
{
	// check if it's an active ban first...
	if (!isbannedid(AuthID))
		return 0
	new bannumber=0
	new i
	// Find the number of the ban
	for (i=0;i<=(COMMBAN_MAXBANS - 1);i++)
	{
		if (equal(AuthID,szBanned[i]))
		{
			bannumber=i
			i += COMMBAN_MAXBANS // break loop
		}
	}
	// start a new loop, and over write old bans
	for (i=bannumber;i<=(COMMBAN_MAXBANS - 2);i++)
	{
		copy(szBanned[i],32,szBanned[i+1])
		BanTime[i]=BanTime[i+1]
	}
	copy(szBanned[COMMBAN_MAXBANS - 1],32,"")
	BanTime[COMMBAN_MAXBANS - 1] = 0
	currentban--
	// Now dump the ban file...
	dump_bans()
	return 1
	
}
public ban_id(banner,AuthId[],btime)
{
	//server_print("Banning: %s Time: %i Banner: %i",AuthId,btime,banner)
	new endbantime
	if (currentban < COMMBAN_MAXBANS)
	{
		endbantime = -1
		if (btime != -1)
		{
			endbantime = time() + (btime * 60)
		}
		// Incase two servers are using the same commban file, we want to
		// re-load all bans, add in the new ban, and re-write the ban.
		// This will help to keep the file in sync with the two server's bans.
		clear_bans()
		precache_bans(0)
		// Add the new ban
		copy(szBanned[currentban],32,AuthId)
		BanTime[currentban]=endbantime
		currentban++
		// Dump them all
		dump_bans()
		// Send verification to the banner.
		client_print(banner,print_console,"[AMX] Commander ban successfully added.")
		return PLUGIN_CONTINUE
	}
	client_print(banner,print_console,"[AMX] Error, too many commander bans!  Clean out your commban.ini or recompile to support more!")
	return PLUGIN_CONTINUE
}
public notifyban(id)
{
	util_nspopup(id,"You have been banned from commanding on this server.")
}
public scoreinfo(index)
{
	SIClass[read_data(1)]=read_data(5) // For indexing of the player's last known "class".
	if (read_data(5) == CLASS_COMMANDER)
	{
		new id = read_data(1)
		new AuthID[32]
		get_user_authid(id, AuthID ,32)
		if (isbannedid(AuthID))
			set_task(0.1,"fixmeup", id)
	}
}
public fixmeup(id)
{
	engclient_cmd(id,"stopcommandermode")
	set_task(0.1,"sendpopup",id)
}
public sendpopup(id)
{
	util_nspopup(id,"Sorry, you are banned from commanding on this server.")
}

public util_nspopup(id,szMessage[])
{
	new msg[192]
	copy(msg,189,szMessage)
	message_begin(MSG_ONE,gmsgHudText2,{0,0,0},id)
	write_string(msg)
	write_byte(0)
	message_end()
}

stock cmd_target2(id,const arg[],flags = 1) {
	new player = find_player("bl",arg)
	if (player)
	{
		if ( player != find_player("blj",arg) )
		{
			console_print(id,"There are more clients matching to your argument")
			return 0    
		}
	}
	else if ( ( player = find_player("c",arg) )==0 && arg[0]=='#' && arg[1] )
		player = find_player("k",str_to_num(arg[1]))    
	if (!player)
	{
		//console_print(id,"Client with that name or userid not found")
		// Had to copy this entire bloody stock because of this line ^^
		return 0
	}
	if (flags & 1)
	{
		if ((get_user_flags(player)&ADMIN_IMMUNITY) && ((flags&2)?(id!=player):true) )
		{
			new imname[32]
			get_user_name(player,imname,31)
			console_print(id,"Client ^"%s^" has immunity",imname)
			return 0
		}
	}
	if (flags & 4)
	{
		if (!is_user_alive(player))
		{
			new imname[32]
			get_user_name(player,imname,31) 
			console_print(id,"That action can't be performed on dead client ^"%s^"",imname)
			return 0
		}
	}
	if (flags & 8)
	{
		if (is_user_bot(player))
		{
			new imname[32]
			get_user_name(player,imname,31) 
			console_print(id,"That action can't be performed on bot ^"%s^"",imname)
			return 0
		} 
	}
	return player
}